const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const subscriptions = sequelize.define(
    'subscriptions',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      status: {
        type: DataTypes.ENUM,

        values: ['active', 'past_due', 'canceled', 'trialing'],
      },

      current_period_start: {
        type: DataTypes.DATE,
      },

      current_period_end: {
        type: DataTypes.DATE,
      },

      payment_provider: {
        type: DataTypes.ENUM,

        values: ['stripe', 'manual', 'none'],
      },

      provider_customer_id: {
        type: DataTypes.TEXT,
      },

      provider_subscription_id: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  subscriptions.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    db.subscriptions.hasMany(db.invoices_saas, {
      as: 'invoices_saas_subscription',
      foreignKey: {
        name: 'subscriptionId',
      },
      constraints: false,
    });

    //end loop

    db.subscriptions.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.subscriptions.belongsTo(db.plans, {
      as: 'plan',
      foreignKey: {
        name: 'planId',
      },
      constraints: false,
    });

    db.subscriptions.belongsTo(db.agences, {
      as: 'agences',
      foreignKey: {
        name: 'agencesId',
      },
      constraints: false,
    });

    db.subscriptions.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.subscriptions.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return subscriptions;
};
